# mongodbcom-tag-manager

`IntegrationBroker()` is a high-performance client-side library housing third party integration scripts made to be consumed by various `mongodb.com/*` repositories.

It also does your taxes.

### Getting started
Via npm
```javascript
import { IntegrationBroker } from '@mongodbjs/mongodb.com-tag-manager'

const { bizible, demandbase, eloqua, intercom, segment } = IntegrationBroker({
  exclude: [/localhost/g, '/my-pathname'],
  segment: 'my api key',
  eloqua: 'my api key'
})

````

Via UMD
```html
<script async onload='IntegrationBroker()'></script>
```

### Integrations
```
- Adroll
- Bizible
- Demandbase
- Eloqua
- Intercom
- Segment
```

### Integration functions:

#### Bizible
```javascript
bizible.push(...)
```

#### Demandbase
```javascript
demandbase.ready(function () {
  demandbase('registry_user_country')
})
```


#### Eloqua
```javascript
eloqua.load('my api key')
eloqua.postForm('IntCMPreRegistrationAtlasUsers1118WW', {
  email
})
```

#### Segment
```javascript
segment.load('my api key')
segment.track(...)
segment.page(...)
segment.identify(...)
segment.getSignupSource()
segment.anonymousId()
```

### Do Taxes
```javascript
IntegrationBroker.doTaxes()
```
