const rollup = require('rollup')

const inputOpts = {
  input: 'index.js'
}

const outputOpts = {
  file: 'bundle.js',
  name: 'initIntegrationBroker',
  format: 'umd'
}

async function build (inputOpts, outputOpts) {
  const bundle = await rollup.rollup(inputOpts)
  await bundle.write(outputOpts)
  console.log('compiled.')
}

async function watch (watchOpts) {
  const watcher = rollup.watch(watchOpts)

  watcher.on('event', function (event) {
    console.log(event.code)
  })
}

if (process.env.NODE_ENV === 'development') {
  watch(Object.assign({}, inputOpts, { output: outputOpts }))
} else {
  build(inputOpts, outputOpts)
}
