import { demandbase } from './demandbase'
import { loadScript } from './util'

function load (key) {
  window.intercomSettings = {
    app_id: key
  }

  if (typeof window.Intercom === 'function') {
    window.Intercom('reattach_activator')
    window.Intercom('update', window.intercomSettings)
    populate()
    return
  }

  const i = function () {
    i.c(arguments)
  }

  i.q = []
  i.c = function (args) {
    i.q.push(args)
  }

  window.Intercom = i

  loadScript({ src: '//widget.intercom.io/widget/qq7v0gqb' })
  populate()
}

function populate () {
  demandbase.ready(function () {
    window.Intercom('update', {
      db_city: demandbase('city'),
      db_company_name: demandbase('company_name'),
      db_country: demandbase('country_name'),
      db_country_code: demandbase('country'),
      db_employee_count: demandbase('employee_count'),
      db_employee_range: demandbase('employee_range'),
      db_forbes_2000: demandbase('forbes_2000'),
      db_fortune_1000: demandbase('fortune_1000'),
      db_industry: demandbase('industry'),
      db_revenue_range: demandbase('revenue_range'),
      db_web_site: demandbase('web_site')
    })
  })
}

export const intercom = { load }
